#include <iostream.h>
#include <string.h>
#define TRUE 1
#define FALSE 0
typedef int Boolean;
typedef struct Header  *Hpointer; //:    .

typedef struct Node 
{
  Node *Suc;
  Node *Alt;
  Boolean Terminal;
  union 
  {
    char Tsym [33];
    Hpointer Nsym;
  } TR;
};

//   .
typedef struct Header
{
  Node* Entry;
  char Sym[33];
};

class Spisok {
  private:
	 Hpointer Goal; //   .
	 char Sym[33];
	 void Parse(Hpointer, Boolean *);
	 void Get_Sym();
  public:
	 Spisok () { Goal = NULL; };
	 void Postr();
	 void Prov();
	 int Razbor();
};

void Spisok::Postr()
//   .
{
  Node *UkZv;   // .
  Node *UkZv1;  // .

  Goal = new (Header);
  strcpy(Goal->Sym,"A");
  // Goal     +-----+
  //   * ---> |  A  |
  //          +-----+
  //          |     |
  //          +-----+
  // ------------------------------
  Goal->Entry = new (Node);
  UkZv = Goal->Entry;
  UkZv->Terminal = TRUE;
  strcpy(UkZv->TR.Tsym,"(");
  // Goal     +-----+
  //   * ---> |  A  |
  //          +-----+
  //          |  *  |
  //          +--|--+
  //             |
  //             V
  //         +----+----+
  // UkZv    |TRUE| (  |
  //  * ---> +----+----+
  //         |    |    |
  //         +----+----+
  // ------------------------------
  UkZv->Alt = new (Node);
  UkZv1 = UkZv->Alt; UkZv1->Terminal = TRUE;
  strcpy(UkZv1->TR.Tsym,"x"); UkZv1->Alt = UkZv1->Suc = NULL;
  // Goal     +-----+
  //   * ---> |  A  |
  //          +-----+
  //          |  *  |
  //          +--|--+
  //             |
  //             V
  //         +----+----+
  // UkZv    |TRUE| (  |
  //  * ---> +----+----+
  //         | *  |    |
  //         +-|--+----+
  //           |
  //           V
  //         +----+----+
  // UkZv1   |TRUE| x  |
  //  * ---> +----+----+
  //         |NULL|NULL|
  //         +----+----+
  // ------------------------------
  UkZv->Suc = new (Node);
  UkZv = UkZv->Suc;  UkZv->Terminal = FALSE;
  UkZv->TR.Nsym = Goal; UkZv->Alt = NULL;
  // Goal     +-----+
  //   * ---> |  A  | <---------------+
  //          +-----+                 |
  //          |  *  |      UkZv *     |
  //          +--|--+           |     |
  //             |              |     |
  //             V              V     |
  //         +-----+-----+   +-----+--|--+
  //         |TRUE |  (  |   |FALSE|  *  |
  //         +-----+-----+   +-----+-----+
  //         |  *  |  * ---->|NULL |     |
  //         +--|--+-----+   +-----+-----+
  //            |
  //            V
  //         +-----+-----+
  // UkZv1   |TRUE |  x  |
  //  * ---> +-----+-----+
  //         |NULL |NULL |
  //         +-----+-----+
  // -----------------------------------------
  UkZv->Suc = new (Node);
  UkZv1 = UkZv->Suc; UkZv1->Terminal = TRUE;
  strcpy(UkZv1->TR.Tsym,"+");
  // Goal     +-----+
  //   * ---> |  A  | <---------------+
  //          +-----+                 |
  //          |  *  |      UkZv *     |   UkZv1 *
  //          +--|--+           |     |         |
  //             |              |     |         |
  //             V              V     |         V
  //         +-----+-----+   +-----+--|--+   +-----+-----+
  //         |TRUE |  (  |   |FALSE|  *  |   |TRUE |  +  |
  //         +-----+-----+   +-----+-----+   +-----+-----+
  //         |  *  |  * ---->|NULL |  * ---->|     |     |
  //         +--|--+-----+   +-----+-----+   +-----+-----+
  //            |
  //            V
  //         +-----+-----+
  //         |TRUE |  x  |
  //         +-----+-----+
  //         |NULL |NULL |
  //         +-----+-----+
  // ------------------------------------------------------
  UkZv1->Suc = new (Node); UkZv1 = UkZv1->Suc;
  UkZv = UkZv->Suc; UkZv1->Terminal = FALSE;
  UkZv1->TR.Nsym = Goal; UkZv1->Alt = NULL; UkZv1->Suc = UkZv;
  //Goal +-----+
  // * ->|  A  | <---------------------------------------------+
  //     +-----+ <---------------+                             |
  //     |  *  |                 |   UkZv *        UkZv1 *     |
  //     +--|--+                 |        |              |     |
  //        |                    |        |              |     |
  //        V                    |        V              V     |
  //     +-----+-----+  +-----+--|--+  +-----+-----+  +-----+--|--+
  //     |TRUE |  (  |  |FALSE|  *  |  |TRUE |  +  |  |FALSE|  *  |
  //     +-----+-----+  +-----+-----+  +-----+-----+  +-----+-----+
  //     |  *  |  * --->|NULL |  * --->|     |  * --->|NULL |  *  |
  //     +--|--+-----+  +-----+-----+  +-----+-----+  +-----+--|--+
  //        |                                ^                 |
  //        V                                +-----------------+
  //     +-----+-----+
  //     |TRUE |  x  |
  //     +-----+-----+
  //     |NULL |NULL |
  //     +-----+-----+
  // --------------------------------------------------------------
  UkZv->Alt = new (Node);
  UkZv = UkZv->Alt; UkZv->Terminal = TRUE;
  strcpy(UkZv->TR.Tsym,"Empty"); UkZv->Alt = NULL;
  //Goal +-----+
  // * ->|  A  | <---------------------------------------------+
  //     +-----+ <---------------+                             |
  //     |  *  |                 |                 UkZv1 *     |
  //     +--|--+                 |                       |     |
  //        |                    |                       |     |
  //        V                    |                       V     |
  //     +-----+-----+  +-----+--|--+  +-----+-----+  +-----+--|--+
  //     |TRUE |  (  |  |FALSE|  *  |  |TRUE |  +  |  |FALSE|  *  |
  //     +-----+-----+  +-----+-----+  +-----+-----+  +-----+-----+
  //     |  *  |  * --->|NULL |  * --->|  *  |  * --->|NULL |  *  |
  //     +--|--+-----+  +-----+-----+  +--|--+-----+  +-----+--|--+
  //        |                             |  ^                 |
  //        |                             |  +-----------------+
  //        V                             V
  //     +-----+-----+                 +-----+-----+
  //     |TRUE |  x  |         UkZv    |TRUE |Empty|
  //     +-----+-----+           * --> +-----+-----+
  //     |NULL |NULL |                 |NULL |     |
  //     +-----+-----+                 +-----+-----+
  // --------------------------------------------------------------
  UkZv->Suc = new (Node); UkZv = UkZv->Suc;
  UkZv->Terminal = TRUE;
  strcpy(UkZv->TR.Tsym,")"); UkZv->Alt = UkZv->Suc = NULL;
  //Goal +-----+
  // * ->|  A  | <---------------------------------------------+
  //     +-----+ <---------------+                             |
  //     |  *  |                 |                 UkZv1 *     |
  //     +--|--+                 |                       |     |
  //        V                    |                       V     |
  //     +-----+-----+  +-----+--|--+  +-----+-----+  +-----+--|--+
  //     |TRUE |  (  |  |FALSE|  *  |  |TRUE |  +  |  |FALSE|  *  |
  //     +-----+-----+  +-----+-----+  +-----+-----+  +-----+-----+
  //     |  *  |  * --->|NULL |  * --->|  *  |  * --->|NULL |  *  |
  //     +--|--+-----+  +-----+-----+  +--|--+-----+  +-----+--|--+
  //        |                             |  ^                 |
  //        |                             |  +-----------------+
  //        V                             V
  //     +-----+-----+                 +-----+-----+  +-----+-----+
  //     |TRUE |  x  |                 |TRUE |Empty|  |TRUE |  )  |
  //     +-----+-----+                 +-----+-----+  +-----+-----+
  //     |NULL |NULL |                 |NULL |  * --->|NULL |NULL |
  //     +-----+-----+                 +-----+-----+  +-----+-----+
  //                                                       ^
  //                                                       |
  //                                                  UkZv *
}

void Spisok::Prov()
//  .
{
  Node *A, *C;  // .
  
  cout << "   ...\n";
  A = Goal->Entry; cout << A->TR.Tsym << " ";
  cout << A->Suc->Suc->TR.Tsym << " ";
  cout << A->Suc->Suc->Alt->Suc->TR.Tsym << " ";
  cout << A->Alt->TR.Tsym << " ";
  C =  A->Suc->TR.Nsym->Entry; cout << C->TR.Tsym << endl;
  cout << " !\n";
}

int Spisok::Razbor()
//  .
{
  Boolean Rez = FALSE;

  //    .
  cout << " ...\n";
  cout << "  -  \"\".\n";
  Get_Sym();
  Parse(Goal,&Rez); cout << endl;
  if  ((Rez) && !strcmp(Sym,".")) return 1;
  else  return 0;
}

void Spisok::Get_Sym()
{
  char Q;
  cin >> Q;
  Sym[0]=Q; Sym[1]='\0';
}

void Spisok::Parse(Hpointer Goal, Boolean *Match)
{
  Node *s;

  s = Goal->Entry;
  do {
      if ( s->Terminal )
      {
        if (!strcmp(s->TR.Tsym,Sym))
          {  (*Match) = TRUE; Get_Sym(); }
        else  (*Match) = !(strcmp(s->TR.Tsym,"Empty"));
      }
      else  Parse (s->TR.Nsym,&(*Match));
      if (*Match)  s = s->Suc;
      else  s = s->Alt;
      }
  while (s!=NULL);
}

void main()
{
  Spisok A;

  //   .
  A.Postr();
  A.Prov();
  if (A.Razbor()) cout <<  " !";
  else cout << "!";
}    